/*
 *	file
 */

#include "vim.h"
#include "globals.h"
#include "proto.h"
#include "option.h"
#include "winime.h"
#ifdef WIN32
# include <windows.h>
#endif


int	h_is_correct( int col, char_u *ptr )
{
	int	i, k;
	if( col==0 )	return(1);
#ifdef WIN32
        if ( IsDBCSLeadByte(*ptr) ) {
#else
	if( *ptr & 0x80 ){
#endif
		for( i=col, k=0 ; i>=0 && (*(ptr-k) & 0x80); k++,i-- );
		return(k%2);
	}
	else	return(1);
}

int IsLeadByte(char_u c)
{
#ifdef WIN32
    return IsDBCSLeadByte(c);
#else
    return (c & 0x80);
#endif
}

int IsTrailByte( char *base, char *p )
{
    int lbc = 0;    /* lead byte count*/

	if ( base >= p )
		return 0;

    while ( p > base ) {
	if ( !IsLeadByte(*(--p)) )
	    break;
	lbc++;
    }

    return (lbc & 1);
}


int AdjustCursorForHangul(void) {

    if ( curwin->w_cursor.col > 0 ) {
        char_u *p;
        p = ml_get(curwin->w_cursor.lnum);
        if ( IsTrailByte(p, p + curwin->w_cursor.col ) ) {
            --curwin->w_cursor.col;
            return 1;
        }
    }

    return 0;
}
       
